Index: /branches/libIGCM_MPI_OpenMP/AA_additionnal
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_additionnal	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_additionnal	(revision 563)
@@ -10,4 +10,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ##################
Index: /branches/libIGCM_MPI_OpenMP/AA_atlas_LMDZ
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_atlas_LMDZ	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_atlas_LMDZ	(revision 563)
@@ -9,4 +9,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ##################
Index: /branches/libIGCM_MPI_OpenMP/AA_atlas_ORCA_LIM
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_atlas_ORCA_LIM	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_atlas_ORCA_LIM	(revision 563)
@@ -9,4 +9,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ##################
Index: /branches/libIGCM_MPI_OpenMP/AA_atlas_ORCHIDEE
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_atlas_ORCHIDEE	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_atlas_ORCHIDEE	(revision 563)
@@ -9,4 +9,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ##################
Index: /branches/libIGCM_MPI_OpenMP/AA_atlas_PISCES
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_atlas_PISCES	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_atlas_PISCES	(revision 563)
@@ -9,4 +9,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ##################
Index: /branches/libIGCM_MPI_OpenMP/AA_create_multi_se
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_create_multi_se	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_create_multi_se	(revision 563)
@@ -9,4 +9,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ###################
Index: /branches/libIGCM_MPI_OpenMP/AA_create_se
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_create_se	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_create_se	(revision 563)
@@ -9,4 +9,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ###################
Index: /branches/libIGCM_MPI_OpenMP/AA_create_ts
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_create_ts	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_create_ts	(revision 563)
@@ -9,4 +9,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ###################
Index: /branches/libIGCM_MPI_OpenMP/AA_job
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_job	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_job	(revision 563)
@@ -10,4 +10,16 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie #!/usr/bin/ksh
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r ::Jobname::       # nom de la requete
+#-Q- curie #MSUB -o Script_Output_::Jobname::.000001    # nom du fichier de sortie
+#-Q- curie #MSUB -e Script_Output_::Jobname::.000001    # nom du fichier de sortie
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n ::JobNumProcTot:: # reservation des processeurs pour le job
+#-Q- curie #MSUB -T 86400             # Limite temps (en secondes)
+#-Q- curie ##MSUB -p XXXXXXX
+#-Q- curie BATCH_NUM_PROC_TOT=$BRIDGE_MSUB_NPROC
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ##################
Index: /branches/libIGCM_MPI_OpenMP/AA_monitoring
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_monitoring	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_monitoring	(revision 563)
@@ -9,4 +9,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ##################
Index: /branches/libIGCM_MPI_OpenMP/AA_rebuild_fromArchive
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_rebuild_fromArchive	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_rebuild_fromArchive	(revision 563)
@@ -9,4 +9,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ###################
Index: /branches/libIGCM_MPI_OpenMP/AA_rebuild_fromWorkdir
===================================================================
--- /branches/libIGCM_MPI_OpenMP/AA_rebuild_fromWorkdir	(revision 562)
+++ /branches/libIGCM_MPI_OpenMP/AA_rebuild_fromWorkdir	(revision 563)
@@ -9,4 +9,11 @@
 #-Q- cesium #MSUB -E "-j o"
 #-Q- cesium #MSUB -E "-S /bin/ksh"
+#-Q- curie ######################
+#-Q- curie ## CURIE   TGCC/CEA ##
+#-Q- curie ######################
+#-Q- curie #MSUB -r TS             # Nom du job               
+#-Q- curie #MSUB -eo
+#-Q- curie #MSUB -n 1              # Reservation du processus
+#-Q- curie #MSUB -T 86400          # Limite de temps elapsed du job
 #-Q- platine #!/usr/bin/ksh
 #-Q- platine ###################
Index: /branches/libIGCM_MPI_OpenMP/libIGCM_sys/libIGCM_sys_curie.ksh
===================================================================
--- /branches/libIGCM_MPI_OpenMP/libIGCM_sys/libIGCM_sys_curie.ksh	(revision 563)
+++ /branches/libIGCM_MPI_OpenMP/libIGCM_sys/libIGCM_sys_curie.ksh	(revision 563)
@@ -0,0 +1,1512 @@
+#!/bin/ksh
+
+#**************************************************************
+# Author: Sebastien Denvil, Martial Mancip, Arnaud Caubel
+# Contact: Arnaud.Caubel__at__lsce.ipsl.fr
+# $Revision::                                          $ Revision of last commit
+# $Author::                                            $ Author of last commit
+# $Date::                                              $ Date of last commit
+# IPSL (2006)
+#  This software is governed by the CeCILL licence see libIGCM/libIGCM_CeCILL.LIC
+#
+#**************************************************************
+
+#=========================================================
+# The documentation of this file can be automatically generated
+# if you use the prefix #D- for comments to be extracted. 
+# Extract with command: cat lib* | grep "^#D-" | cut -c "4-"
+#=========================================================
+
+#D-#==================================================
+#D-LibIGCM_sys for Titane
+#D-#==================================================
+#D-
+#D- This ksh library if a layer under some usefull 
+#D-environment variables and shell commands.
+#D-All those definitions depend on host particularities.
+#D-It manages a stack mechanism and test validity of operations.
+#D-All function described bellow must be prefixed by IGCM_sys.
+
+#====================================================
+# libIGCM_sys PARAMETERS
+#====================================================
+
+#====================================================
+# set DEBUG_sys to true to output calls of function
+typeset -r DEBUG_sys=${DEBUG_sys:=true}
+
+#====================================================
+# Turn in dry run mode ? (sys_Put_Rest, sys_Put_Out, sys_Get)
+typeset -r DRYRUN=${DRYRUN:=0}
+
+# YOU MUST COMPILE YOUR EXE FILES FOR DRYRUN MODE !
+# -------------------------------------------------------------------------------------
+# | DRYRUN=  |  Date computations, | sys_Get    |  Exe    | sys_Put_Out; sys_Put_Rest |
+# |          |  Cp/Exe param files |            |  Chmod  |                           |
+# |          |      Qsub           |            |         |                           |
+# -------------------------------------------------------------------------------------
+# |    0     |       yes           |    yes     |  yes    |      yes                  |
+# -------------------------------------------------------------------------------------
+# |    1     |       yes           |    yes     |  yes    |      no                   |
+# -------------------------------------------------------------------------------------
+# |    2     |       yes           |    yes     |  no     |      no                   |
+# -------------------------------------------------------------------------------------
+# |    3     |       yes           |    no      |  no     |      no                   |
+# -------------------------------------------------------------------------------------
+
+#=====================================================
+# Global Variables :
+#=====================================================
+# Language : "fr" or "en"
+typeset -r MYLANG="fr"
+
+#=====================================================
+# Host and user names
+# $hostname ou hostname
+typeset  HOST=${HOST:=$( hostname )}
+# $username ou whoami
+typeset  LOGIN=${LOGIN:=$( whoami )}
+# $hostname of the MASTER job
+typeset MASTER=curie
+
+#D-
+#D-#==================================================
+#D-Program used in libIGCM
+#D-#==================================================
+
+# rsync with path
+typeset -r RSYNC=/usr/bin/rsync
+# RSYNC_opt args to rsync
+typeset -r RSYNC_opt="-va"
+# ie storage filesystem
+typeset -r RHOST=curie
+
+#====================================================
+# Source default environment
+#====================================================
+. /etc/profile
+
+#====================================================
+# Set environment tools (ferret, nco, cdo)
+#====================================================
+. /ccc/cont003/home/dsm/p86ipsl/.atlas_env_curie_ksh
+
+#====================================================
+# Specific for ocean additionnal diagnostic
+export FER_GO="$FER_GO /home/cont003/p86denv/IGCM_POST_UTIL/JNL /home/cont003/p86denv/GRAF /home/cont003/p86denv/GRAF/GO"
+export FER_PALETTE="$FER_PALETTE /home/cont003/p86denv/GRAF/PALET"
+
+#====================================================
+# Host specific DIRECTORIES
+#====================================================
+
+#====================================================
+#- R_EXE   (==> BIN_DIR = ${MODIPSL}/bin )
+typeset -r R_EXE="${MODIPSL}/bin"
+
+#====================================================
+#- SUBMIT_DIR : submission dir
+typeset SUBMIT_DIR=${SUBMIT_DIR:=${BRIDGE_MSUB_PWD}}
+
+#====================================================
+#- ARCHIVE
+typeset -r ARCHIVE=${CCCSTOREDIR}
+
+#====================================================
+typeset -r MirrorlibIGCM=${MirrorlibIGCM:=false}
+
+#====================================================
+#- libIGCM_POST
+typeset -r libIGCM_POST=${libIGCM}
+
+#====================================================
+#- IN
+typeset -r R_IN=${R_IN:=/ccc/work/cont003/dsm/p86ipsl/IGCM}
+typeset -r R_IN_ECMWF=${R_IN_ECMWF:=/ccc/work/cont003/dsm/p24data}
+
+#====================================================
+#- OUT
+typeset -r R_OUT=${ARCHIVE}/IGCM_OUT
+
+#====================================================
+#- OUT_SCR (ONLY FOR double copy an scratch)
+typeset -r R_OUT_SCR=${SCRATCHDIR}/IGCM_OUT
+
+#====================================================
+#- OUT_POST
+typeset -r R_OUT_POST=${SCRATCHDIR}/IGCM_OUT_POST
+
+#====================================================
+#- RUN_DIR_PATH : Temporary working directory (=> TMP)
+if [ ! X${BRIDGE_MSUB_NPROC} = X1 ] ; then
+    typeset -r RUN_DIR_PATH=${RUN_DIR_PATH:=${SCRATCHDIR}/RUN_DIR/${BRIDGE_MSUB_JOBID}}
+else
+    typeset -r RUN_DIR_PATH=${RUN_DIR_PATH:=${SCRATCHDIR}/TMPDIR_IGCM/${BRIDGE_MSUB_JOBID}}
+fi
+
+#====================================================
+#- BIG_DIR : BIG_DIR to store files waiting for rebuild
+typeset -r BIG_DIR=${BIG_DIR:=${SCRATCHDIR}/REBUILD}
+
+#====================================================
+#- HOST_MPIRUN_COMMAND
+typeset -r HOST_MPIRUN_COMMAND=${HOST_MPIRUN_COMMAND:="time ccc_mprun"}
+
+#====================================================
+#- Max number of arguments passed to nco operator or demigration command
+UNIX_MAX_LIMIT=360
+
+NUM_COREPERNODE=8
+	
+
+#D-#==================================================
+#D-function IGCM_sys_RshMaster
+#D-* Purpose: Just a fake command to wrapp
+#D-           IGCM_card call in post-treatment
+#D-           Ulam do not see brodie filesystem
+#D-           Cesium do not see all mercure filesystem
+#D-           That's why we need this hack.
+#D-* Examples:
+#D-
+function IGCM_sys_RshMaster {
+    IGCM_debug_PushStack "IGCM_sys_RshMaster" $@
+    /bin/ksh <<-EOF
+    export libIGCM=${libIGCM}
+    export DEBUG_debug=${DEBUG_debug}
+    . ${libIGCM}/libIGCM_debug/libIGCM_debug.ksh
+    . ${libIGCM}/libIGCM_card/libIGCM_card.ksh
+    ${@}
+EOF
+    if [ $? -gt 0 ] ; then
+	echo "IGCM_sys_RshMaster : erreur."
+	IGCM_debug_Exit "IGCM_sys_RshMaster"
+    fi
+    IGCM_debug_PopStack "IGCM_sys_RshMaster"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_RshArchive
+#D-* Purpose: Archive rsh command
+#D-* Examples:
+#D-
+function IGCM_sys_RshArchive {
+    IGCM_debug_PushStack "IGCM_sys_RshArchive" $@
+    /bin/ksh <<-EOF
+    ${@}
+EOF
+    if [ $? -gt 0 ] ; then
+	echo "IGCM_sys_RshArchive : erreur."
+	IGCM_debug_Exit "IGCM_sys_RshArchive"
+    fi
+    IGCM_debug_PopStack "IGCM_sys_RshArchive"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_RshPost
+#D-* Purpose: Post-process rsh command
+#D-* Examples:
+#D-
+function IGCM_sys_RshPost {
+    IGCM_debug_PushStack "IGCM_sys_RshPost" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_RshPost :" $@
+    fi
+
+	/bin/ksh ${@}
+	if [ $? -gt 0 ] ; then
+	    echo "IGCM_sys_RshPost : erreur."
+	    IGCM_debug_Exit "IGCM_sys_RshPost"
+	fi
+    IGCM_debug_PopStack "IGCM_sys_RshPost"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_SendMail
+#D-* Purpose: Send mail when simulation is over
+#D-* Examples:
+#D-
+function IGCM_sys_SendMail {
+    IGCM_debug_PushStack "IGCM_sys_SendMail" $@
+    if ( $DEBUG_sys ) ; then
+       echo "IGCM_sys_SendMail :" $@
+    fi
+
+    if ( ${ExitFlag} ) ; then
+	status=failed
+    else
+	status=completed
+    fi
+
+    cat  << END_MAIL > job_end.mail
+Dear ${LOGIN},
+
+  Simulation ${config_UserChoices_JobName} is ${status} on supercomputer `hostname`.
+  Job started : ${DateBegin}
+  Job ended   : ${DateEnd}
+  Output files are available in ${R_SAVE}
+  Script files, Script Outputs and Debug files (if necessary) are available in ${SUBMIT_DIR}
+END_MAIL
+
+    if [ ! -z ${config_UserChoices_MailName} ] ; then
+	mail -s "${config_UserChoices_JobName} ${status}" ${config_UserChoices_MailName} < job_end.mail
+    elif [ -f ~/.forward ] ; then
+	mail -s "${config_UserChoices_JobName} ${status}" $( cat ~/.forward ) < job_end.mail
+    else
+    mail -s "${config_UserChoices_JobName} ${status}" ${USER} < job_end.mail
+    fi
+
+    if [ $? -gt 0 ] ; then
+	echo "IGCM_sys_SendMail : erreur."
+	IGCM_debug_Exit "IGCM_sys_SendMail"
+    fi
+    IGCM_debug_PopStack "IGCM_sys_SendMail"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Mkdir
+#D-* Purpose: Master locale mkdir command
+#D-* Examples:
+#D-
+function IGCM_sys_Mkdir {
+    IGCM_debug_PushStack "IGCM_sys_Mkdir" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Mkdir :" $@
+    fi
+    if [ ! -d ${1} ]; then
+	\mkdir -p $1
+	if [ $? -gt 0 ] ; then
+	    echo "IGCM_sys_Mkdir : erreur."
+	    IGCM_debug_Exit "IGCM_sys_Mkdir"
+	fi
+    fi
+    # verification :
+    if [ ! -d ${1} ] ; then
+	echo "IGCM_sys_Mkdir : erreur."
+	IGCM_debug_Exit "IGCM_sys_Mkdir"
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Mkdir"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_MkdirArchive
+#D-* Purpose: Mkdir on Archive
+#D-* Examples:
+#D-
+function IGCM_sys_MkdirArchive {
+    IGCM_debug_PushStack "IGCM_sys_MkdirArchive" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_MkdirArchive :" $@
+    fi
+    #- creation de repertoire sur le serveur fichier
+    if [ ! -d ${1} ]; then 
+	\mkdir -p $1
+	if [ $? -gt 0 ] ; then
+	    echo "IGCM_sys_MkdirArchive : erreur."
+	    IGCM_debug_Exit "IGCM_sys_MkdirArchive"
+	fi
+    fi
+    IGCM_debug_PopStack "IGCM_sys_MkdirArchive"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_MkdirWork
+#D-* Purpose: Mkdir on Work
+#D-* Examples:
+#D-
+function IGCM_sys_MkdirWork {
+    IGCM_debug_PushStack "IGCM_sys_MkdirWork" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_MkdirWork :" $@
+    fi
+    #- creation de repertoire sur le serveur fichier
+    if [ ! -d ${1} ]; then 
+	\mkdir -p $1
+	if [ $? -gt 0 ] ; then
+	    echo "IGCM_sys_MkdirWork : erreur."
+	    IGCM_debug_Exit "IGCM_sys_MkdirWork"
+	fi
+    fi
+    IGCM_debug_PopStack "IGCM_sys_MkdirWork"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Cd
+#D-* Purpose: master cd command
+#D-* Examples:
+#D-
+function IGCM_sys_Cd {
+    IGCM_debug_PushStack "IGCM_sys_Cd" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Cd :" $@
+    fi
+    \cd $1
+    if [ $? -gt 0 ] ; then
+	echo "IGCM_sys_Cd : erreur."
+	IGCM_debug_Exit "IGCM_sys_Cd"
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Cd"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Chmod
+#D-* Purpose: Chmod
+#D-* Examples:
+#D-
+function IGCM_sys_Chmod {
+    IGCM_debug_PushStack "IGCM_sys_Chmod" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Chmod :" $@
+    fi
+    if [ $DRYRUN -le 1 ]; then
+	\chmod $@
+	if [ $? -gt 0 ] ; then
+	    echo "IGCM_sys_Chmod : erreur."
+	    IGCM_debug_Exit "IGCM_sys_Chmod"
+	fi
+    else
+	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Chmod"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_FileSize
+#D-* Purpose: Filesize
+#D-* Examples:
+#D-
+function IGCM_sys_FileSize {
+    IGCM_debug_PushStack "IGCM_sys_FileSize" $@
+
+    typeset sizeF
+    set +A sizeF -- $( ls -la ${1} )
+    if [ $? -gt 0 ] ; then
+	IGCM_debug_Exit "IGCM_sys_FileSize"
+    fi
+    eval ${2}=${sizeF[4]}
+
+    IGCM_debug_PopStack "IGCM_sys_FileSize"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_TestDir
+#D-* Purpose: Test Directory that must exists
+#D-* Examples:
+#D-
+function IGCM_sys_TestDir {
+    IGCM_debug_PushStack "IGCM_sys_TestDir" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_TestDir :" $@
+    fi
+    typeset ExistFlag
+    ExistFlag=$( [ -d $1 ] && echo 0 || echo 1 )
+    IGCM_debug_PopStack "IGCM_sys_TestDir"
+
+    return ${ExistFlag}
+}
+
+#D-#==================================================
+#D-function IGCM_sys_TestDirArchive
+#D-* Purpose: Test Directory that must exists on Archive
+#D-* Examples:
+#D-
+function IGCM_sys_TestDirArchive {
+    IGCM_debug_PushStack "IGCM_sys_TestDirArchive" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_TestDirArchive :" $@
+    fi
+    typeset ExistFlag
+    ExistFlag=$( [ -d $1 ] && echo 0 || echo 1 )
+    IGCM_debug_PopStack "IGCM_sys_TestDirArchive"
+
+    return ${ExistFlag}
+}
+
+#D-#==================================================
+#D-function IGCM_sys_TestFileArchive
+#D-* Purpose: Test file that must NOT EXISTS on Archive
+#D-* Examples:
+#D-
+function IGCM_sys_TestFileArchive {
+    IGCM_debug_PushStack "IGCM_sys_TestFileArchive" $@
+    typeset ExistFlag
+    ExistFlag=$( [ -f $1 ] && echo 0 || echo 1 )
+    IGCM_debug_PopStack "IGCM_sys_TestFileArchive"
+
+    return ${ExistFlag}
+}
+
+#D-#==================================================
+#D-function IGCM_sys_CountFileArchive
+#D-* Purpose: Count files on Archive filesystem
+#D-* Examples:
+#D-
+function IGCM_sys_CountFileArchive {
+    IGCM_debug_PushStack "IGCM_sys_CountFileArchive" $@
+    ls ${@} 2>/dev/null | wc -l
+    if [ $? -gt 0 ] ; then
+	echo "IGCM_sys_CountFileArchive : erreur."
+    fi
+    IGCM_debug_PopStack "IGCM_sys_CountFileArchive"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Tree
+#D-* Purpose: Tree directories with files on ${ARCHIVE}
+#D-* Examples: IGCM_sys_Tree ${R_IN} ${R_OUT}
+#D-
+function IGCM_sys_Tree {
+    IGCM_debug_PushStack "IGCM_sys_Tree" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Tree :" $@
+    fi
+
+    \ls -lR ${@}
+
+    IGCM_debug_PopStack "IGCM_sys_Tree"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Tar
+#D-* Purpose: master un-tar command
+#D-* Examples:
+#D-
+function IGCM_sys_Tar {
+    IGCM_debug_PushStack "IGCM_sys_Tar" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Tar :" $@
+    fi
+    \tar xvf $1
+    if [ $? -gt 0 ] ; then
+	echo "IGCM_sys_Tar : erreur."
+	IGCM_debug_Exit "IGCM_sys_Tar"
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Tar"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_UnTar
+#D-* Purpose: master un-tar command
+#D-* Examples:
+#D-
+function IGCM_sys_UnTar {
+    IGCM_debug_PushStack "IGCM_sys_UnTar" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_UnTar :" $@
+    fi
+    \tar xvf $1
+    if [ $? -gt 0 ] ; then
+	echo "IGCM_sys_UnTar : erreur."
+	IGCM_debug_Exit "IGCM_sys_UnTar"
+    fi
+    IGCM_debug_PopStack "IGCM_sys_UnTar"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Qsub
+#D-* Purpose: Qsub new job
+#D-* Examples:
+#D-
+function IGCM_sys_Qsub {
+    IGCM_debug_PushStack "IGCM_sys_Qsub" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Qsub :" $@
+    fi
+
+    if [ ${config_UserChoices_JobName}.${CumulPeriod} = "." ] ; then
+        /usr/bin/ccc_msub -o ${Script_Output} -e ${Script_Output} < $1
+    else
+        /usr/bin/ccc_msub -o ${Script_Output} -e ${Script_Output} -r ${config_UserChoices_JobName}.${CumulPeriod} < $1
+    fi
+
+    if [ $? -gt 0 ] ; then
+	echo "IGCM_sys_Qsub : erreur " $@
+	IGCM_debug_Exit "IGCM_sys_Qsub"
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Qsub"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_QsubPost
+#D-* Purpose: Qsub new job on scalaire
+#D-* Examples:
+#D-
+function IGCM_sys_QsubPost {
+    IGCM_debug_PushStack "IGCM_sys_QsubPost" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_QsubPost :" $@
+    fi
+    /usr/bin/ccc_msub -o ${POST_DIR}/${Script_Post_Output}.out -e ${POST_DIR}/${Script_Post_Output}.out ${libIGCM_POST}/$1.job
+    if [ $? -gt 0 ] ; then
+	echo "IGCM_sys_QsubPost : erreur " $@
+	IGCM_debug_Exit "IGCM_sys_QsubPost"
+    fi
+    IGCM_debug_PopStack "IGCM_sys_QsubPost"
+}
+
+#D-*************************
+#D- File transfer functions 
+#D-*************************
+#D-
+
+#D-#==================================================
+#D-function IGCM_sys_Rsync_out
+#D-* Purpose: treat return val of rsync
+#D-* Examples: IGCM_sys_Rsync_out out_RET_rsync
+#D-  Error values and explanations can depend on your system version.
+function IGCM_sys_Rsync_out {
+    RET=$1
+    if [ ! $RET ] ; then
+	echo "rsync error !"
+    fi
+
+    if [ $MYLANG = "fr" ]; then
+	case $RET in
+	    0)  return ;;
+	    1)  echo "Erreur de rsync ; RERR_SYNTAX : "
+		echo "Erreur de syntaxe ou d'utilisation."
+		return;;
+	    2)  echo "Erreur de rsync ; RERR_PROTOCOL : "
+		echo "Incompatibilité de protocole."
+		return;;
+	    3)  echo "Erreur de rsync ; RERR_FILESELECT 3"
+		echo "Erreurs  lors  de  la  sélection des fichiers d'entrée sortie et"
+		echo "répertoires"
+		return;;
+	    4)  echo "Erreur de rsync ; RERR_UNSUPPORTED"
+		echo "Action demandée non supportée : une tentative de manipulation de"
+		echo "fichiers  64-bits  sur une plate-forme qui ne les supporte pas a"
+		echo "été faite ; ou une option qui est supportée par le  client  mais"
+		echo "pas par le serveur a été spécifiée."
+		return;;
+	    10) echo "Erreur de rsync ; RERR_SOCKETIO"
+		echo "Erreur dans le socket d'entrée sortie"
+		return;;
+	    11) echo "Erreur de rsync ; RERR_FILEIO"
+		echo "Erreur d'entrée sortie fichier"
+		return;;
+	    12) echo "Erreur de rsync ; RERR_STREAMIO"
+		echo "Erreur dans flux de donnée du protocole rsync"
+		return;;
+	    13) echo "Erreur de rsync ; RERR_MESSAGEIO"
+		echo "Erreur avec les diagnostics du programme"
+		return;;
+	    14) echo "Erreur de rsync ; RERR_IPC"
+		echo "Erreur dans le code IPC"
+		return;;
+	    20) echo "Erreur de rsync ; RERR_SIGNAL"
+		echo "SIGUSR1 ou SIGINT reçu"
+		return;;
+	    21) echo "Erreur de rsync ; RERR_WAITCHILD"
+		echo "Une erreur retournée par waitpid()"
+		return;;
+	    22) echo "Erreur de rsync ; RERR_MALLOC"
+		echo "Erreur lors de l'allocation des tampons de mémoire de coeur"
+		return;;
+	    23) echo ""
+                echo "Erreur fichier inexistant"
+		return;;
+	    30) echo "Erreur de rsync ; RERR_TIMEOUT"
+		echo "Temps d'attente écoulé dans l'envoi/réception de données"
+		return;;
+	    *)  echo "Erreur de rsync : code de retour de rsync inconnu :" $RET
+		return;;
+	esac
+    elif [ $MYLANG = "en" ] ; then
+	case $RET in
+	    0)  return;;		
+	    1)  echo "rsync error : Syntax or usage error "
+		return;;
+	    2)  echo "rsync error : Protocol incompatibility "
+		return;;
+	    3)  echo "rsync error : Errors selecting input/output files, dirs"
+		return;;
+	    4)  echo "rsync error : Requested action not supported: an attempt"
+		echo "was made to manipulate 64-bit files on a platform that cannot support"
+		echo "them; or an option was specified that is supported by the client and"
+		echo "not by the server."
+		return;;
+	    5)  echo "rsync error : Error starting client-server protocol"
+		return;;
+	    10) echo "rsync error : Error in socket I/O "
+		return;;
+	    11) echo "rsync error : Error in file I/O "
+		return;;
+	    12) echo "rsync error : Error in rsync protocol data stream "
+		return;;
+	    13) echo "rsync error : Errors with program diagnostics "
+		return;;
+	    14) echo "rsync error : Error in IPC code "
+		return;;
+	    20) echo "rsync error : Received SIGUSR1 or SIGINT "
+		return;;
+	    21) echo "rsync error : Some error returned by waitpid() "
+		return;;
+	    22) echo "rsync error : Error allocating core memory buffers "
+		return;;
+	    23) echo "rsync error : Partial transfer due to error"
+		return;;
+	    24) echo "rsync error : Partial transfer due to vanished source files"
+		return;;
+	    30) echo "rsync error : Timeout in data send/receive "
+		return;;
+	    *)  echo "rsync error : return code of rsync unknown :" $RET
+		return;;
+	esac
+    else
+	echo "unknown language $MYLANG."
+	return
+    fi
+}
+    
+
+#D-#==================================================
+#D-function IGCM_sys_Miror_libIGCM
+#D-* Purpose: Mirror libIGCM PATH and lib to cesium
+#D-* Examples:
+#D-
+function IGCM_sys_Mirror_libIGCM {
+    IGCM_debug_PushStack "IGCM_sys_Mirror_libIGCM"
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Mirror_libIGCM"
+    fi
+
+    typeset RET DEST
+
+    mkdir -p ${HOME}/MIRROR/${PATHlibIGCM}
+
+    echo ${RSYNC} ${RSYNC_opt} ${libIGCM} ${HOME}/MIRROR/${PATHlibIGCM} > out_rsync 2>&1
+    ${RSYNC} ${RSYNC_opt} ${libIGCM} ${HOME}/MIRROR/${PATHlibIGCM} >> out_rsync 2>&1
+    RET=$?
+
+    if [ ${RET} -gt 0 ] ; then
+	echo "IGCM_sys_Mirror_libIGCM Warning : no libIGCM on cesium."
+	cat out_rsync
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Mirror_libIGCM"
+}
+
+#====================================================
+#- Call IGCM_sys_Mirror_libIGCM now !
+if ( $MirrorlibIGCM ) ; then
+    IGCM_sys_Mirror_libIGCM
+fi
+
+#D-#==================================================
+#D-function IGCM_sys_Cp
+#D-* Purpose: generic cp
+#D-* Examples:
+#D-
+function IGCM_sys_Cp {
+    IGCM_debug_PushStack "IGCM_sys_Cp" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Cp :" $@
+    fi
+
+    typeset RET
+
+    echo cp $@ > out_rsync 2>&1
+    \cp $@ >> out_rsync 2>&1
+    RET=$?
+
+    if [ ${RET} -gt 0 ] ; then
+	echo "IGCM_sys_Cp : error."
+	cat out_rsync
+	IGCM_debug_Exit "IGCM_sys_Cp"
+     else
+	 \rm out_rsync
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Cp"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Rm
+#D-* Purpose: generic rm
+#D-* Examples:
+#D-
+function IGCM_sys_Rm {
+    IGCM_debug_PushStack "IGCM_sys_Rm" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Rm :" $@
+    fi
+
+    typeset RET
+
+    echo rm $@ > out_rsync 2>&1
+    \rm $@ >> out_rsync 2>&1
+    RET=$?
+
+    if [ ${RET} -gt 0 ] ; then
+	echo "IGCM_sys_Rm : error."
+	cat out_rsync
+	IGCM_debug_Exit "IGCM_sys_Rm"
+    else
+	\rm out_rsync
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Rm"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_RmRunDir
+#D-* Purpose: rm tmpdir (dummy function most of the time batch
+#D-                      scheduler will do the job)
+#D-* Examples:
+#D-
+function IGCM_sys_RmRunDir {
+    IGCM_debug_PushStack "IGCM_sys_RmRunDir" -- $@
+    if ( $DEBUG_sys ) ; then
+        echo "IGCM_sys_RmRunDir :" $@
+    fi
+
+    typeset RET
+
+    echo rm $@ > out_rsync 2>&1
+    \rm $@ >> out_rsync 2>&1
+    RET=$?
+
+    if [ ${RET} -gt 0 ] ; then
+        echo "IGCM_sys_RmRunDir : error."
+        cat out_rsync
+        IGCM_debug_Exit "IGCM_sys_RmRunDir"
+    else
+        \rm out_rsync
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_RmRunDir"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Mv
+#D-* Purpose: generic move
+#D-* Examples:
+#D-
+function IGCM_sys_Mv {
+    IGCM_debug_PushStack "IGCM_sys_Mv" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Mv :" $@
+    fi
+
+    if [ $DRYRUN = 0 ]; then
+
+        typeset RET
+            
+        echo mv $@ > out_rsync 2>&1
+        \mv $@ >> out_rsync 2>&1
+        RET=$?
+    
+        if [ ${RET} -gt 0 ] ; then
+            echo "IGCM_sys_Mv : error in mv."
+            cat out_rsync
+            IGCM_debug_Exit "IGCM_sys_Mv"
+	else
+	    \rm out_rsync
+        fi
+    else
+        ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_Mv"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Put_Dir
+#D-* Purpose: Copy a complete directory on $(ARCHIVE)
+#D-* Examples:
+#D-
+function IGCM_sys_Put_Dir {
+    IGCM_debug_PushStack "IGCM_sys_Put_Dir" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Put_Dir :" $@
+    fi
+    if [ $DRYRUN = 0 ]; then
+	if [ ! -d ${1} ] ; then
+	    echo "WARNING : IGCM_sys_Put_Dir ${1} DOES NOT EXIST ."
+	    IGCM_debug_PopStack "IGCM_sys_Put_Dir"
+	    return
+	fi
+
+	typeset RET
+
+	# Only if we use rsync
+	#IGCM_sys_TestDirArchive $( dirname $2 )
+	#
+	#USUAL WAY
+	\cp -r $1 $2 > out_rsync 2>&1
+  	RET=$?
+
+	if [ ${RET} -gt 0 ] ; then
+	    echo "IGCM_sys_Put_Dir : error."
+	    cat out_rsync
+	    IGCM_debug_Exit "IGCM_sys_Put_Dir"
+	else
+	    \rm out_rsync
+	fi
+    else
+	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Put_Dir"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Get_Dir
+#D-* Purpose: Copy a complete directory from $(ARCHIVE)
+#D-* Examples:
+#D-
+function IGCM_sys_Get_Dir {
+    IGCM_debug_PushStack "IGCM_sys_Get_Dir" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Get_Dir :" $@
+    fi
+    if [ $DRYRUN = 0 ]; then
+#	if [ ! -d ${1} ] ; then
+#	    echo "WARNING : IGCM_sys_Get_Dir ${1} DOES NOT EXIST ."
+#	    IGCM_debug_PopStack "IGCM_sys_Get_Dir"
+#	    return
+#	fi
+
+	typeset RET
+
+	# Only if we use rsync
+	#IGCM_sys_TestDirArchive $( dirname $2 )
+	#
+	#USUAL WAY
+        # add get (to demigrate all offline files) to reduce time of this command :
+        ccc_hsm get $1/*
+	\cp -r $1 $2 > out_rsync 2>&1
+  	RET=$?
+
+	if [ ${RET} -gt 0 ] ; then
+	    echo "IGCM_sys_Get_Dir : error."
+	    cat out_rsync
+	    IGCM_debug_Exit "IGCM_sys_Get_Dir"
+	else
+	    \rm out_rsync
+	fi
+    else
+	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Get_Dir"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Get_Master
+#D-* Purpose: Copy a complete directory from MASTER filesystem
+#D-* Examples:
+#D-
+function IGCM_sys_Get_Master {
+    IGCM_debug_PushStack "IGCM_sys_Get_Master" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Get_Master :" $@
+    fi
+    if [ $DRYRUN = 0 ]; then
+	if [ ! -d ${1} ] ; then
+	    echo "WARNING : IGCM_sys_Get_Master ${1} DOES NOT EXIST ."
+	    IGCM_debug_PopStack "IGCM_sys_Get_Master"
+	    return
+	fi
+
+	typeset RET
+
+	#USUAL WAY
+	\cp -r $1 $2 > out_rsync 2>&1
+  	RET=$?
+
+	if [ ${RET} -gt 0 ] ; then
+	    echo "IGCM_sys_Get_Master : error."
+	    cat out_rsync
+	    IGCM_debug_Exit "IGCM_sys_Get_Master"
+	fi
+    else
+	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Get_Master"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Put_Rest
+#D-* Purpose: Put computied restarts on $(ARCHIVE).
+#D-           File and target directory must exist.
+#D-* Examples:
+#D-
+function IGCM_sys_Put_Rest {
+    IGCM_debug_PushStack "IGCM_sys_Put_Rest" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Put_Rest :" $@
+    fi
+    if [ $DRYRUN = 0 ]; then
+	if [ ! -f ${1} ] ; then
+	    echo "ERROR : IGCM_sys_Put_Rest ${1} DOES NOT EXIST ."
+	    IGCM_debug_Exit "IGCM_sys_Put_Rest"
+	fi
+
+	typeset RET
+	#
+	if [ X${JobType} = XRUN ] ; then
+	    IGCM_sys_Chmod 444 ${1}
+	fi
+	#
+	IGCM_sys_TestDirArchive $( dirname $2 )
+	#
+	# USUAL WAY
+	\cp $1 $2 > out_rsync 2>&1
+        RET=$?
+
+# 	#RSYNC WITH NETWORK SSH CALL
+# 	echo ${RSYNC} ${RSYNC_opt} -e ssh ${RUN_DIR}/$1 ${RHOST}:${2} > out_rsync 2>&1
+# 	${RSYNC} ${RSYNC_opt} -e ssh ${RUN_DIR}/$1 ${RHOST}:${2} >> out_rsync 2>&1
+
+#  	#RSYNC WITH NFS USE
+#  	echo ${RSYNC} ${RSYNC_opt} ${RUN_DIR}/$1 ${2} > out_rsync 2>&1
+#  	${RSYNC} ${RSYNC_opt} ${RUN_DIR}/$1 ${2} >> out_rsync 2>&1
+
+#  	RET=$?
+#  	IGCM_sys_Rsync_out $RET
+
+#  	${libIGCM}/libIGCM_sys/IGCM_analyse_rsync_out.awk out_rsync
+#  	(( RET=RET+$? ))
+
+	if [ ${RET} -gt 0 ] ; then
+	    echo "IGCM_sys_Put_Rest : error."
+	    cat out_rsync
+	    IGCM_debug_Exit "IGCM_sys_Put_Rest"
+	else
+	    \rm out_rsync
+	fi
+    else
+	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Put_Rest"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Put_Out
+#D-* Purpose: Copy a file on $(ARCHIVE) after have chmod it in readonly
+#D-* Examples:
+#D-
+function IGCM_sys_Put_Out {
+    IGCM_debug_PushStack "IGCM_sys_Put_Out" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Put_Out :" $@
+    fi
+    if [ $DRYRUN = 0 ]; then
+	if [ ! -f ${1} ] ; then
+	    echo "WARNING : IGCM_sys_Put_Out ${1} DOES NOT EXIST ."
+	    IGCM_debug_PopStack "IGCM_sys_Put_Out"
+	    return 1
+	fi
+	#
+	IGCM_sys_MkdirArchive $( dirname $2 )
+        #
+	typeset RET
+
+	#=====================================================
+        #         COMMENT OUT DOUBLE COPY ON SCRATCHDIR
+        #=====================================================
+
+	#echo ${2} | grep "${R_OUT}" > /dev/null 2>&1
+	#if [ $? -eq 0 ] ; then
+	#    typeset WORKPATH FILEPATH
+	#    WORKPATH=$( dirname $2 | sed -e "s|${R_OUT}|${R_OUT_SCR}|" )
+	#    IGCM_sys_MkdirWork ${WORKPATH} 
+	#    FILEPATH=${WORKPATH}/$( basename $2 )
+        #    #
+	#    IGCM_sys_Cp ${1} ${FILEPATH}
+	#fi
+
+	if [ X${JobType} = XRUN ] ; then
+	    if [ X${3} = X ] ; then
+		IGCM_sys_Chmod 444 ${1}
+	    fi
+	fi
+	#
+        # USUAL WAY
+	\cp $1 $2 > out_rsync 2>&1
+	RET=$?
+
+# 	#RSYNC WITH NETWORK SSH CALL
+# 	echo ${RSYNC} ${RSYNC_opt} -e ssh ${RUN_DIR}/$1 ${RHOST}:${2} > out_rsync 2>&1
+# 	${RSYNC} ${RSYNC_opt} -e ssh ${RUN_DIR}/$1 ${RHOST}:${2} >> out_rsync 2>&1
+
+#  	#RSYNC WITH NFS USE
+#  	echo ${RSYNC} ${RSYNC_opt} ${RUN_DIR}/$1 ${2} > out_rsync 2>&1
+#  	${RSYNC} ${RSYNC_opt} ${RUN_DIR}/$1 ${2} >> out_rsync 2>&1
+
+#  	RET=$?
+#  	IGCM_sys_Rsync_out $RET
+
+#  	${libIGCM}/libIGCM_sys/IGCM_analyse_rsync_out.awk out_rsync
+#  	(( RET=RET+$? ))
+
+	if [ ${RET} -gt 0 ] ; then
+	    echo "IGCM_sys_Put_Out : error."
+	    cat out_rsync
+	    IGCM_debug_Exit "IGCM_sys_Put_Out"
+	else
+	    \rm out_rsync
+	fi
+    else
+	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Put_Out"
+    return 0
+}
+
+#D-#==================================================
+#D-function IGCM_sys_Get
+#D-* Purpose: Get a file from ${ARCHIVE}
+#D-* Examples: IGCM_sys_Get myfile /destpath/myfile_with_PREFIX
+#D-            IGCM_sys_Get /l Array_contain_myfiles /destpath/
+function IGCM_sys_Get {
+    IGCM_debug_PushStack "IGCM_sys_Get" $@
+
+    typeset DEST RET dm_liste ifile target file_work 
+
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_Get :" $@
+    fi
+    if [ $DRYRUN -le 2 ]; then
+	if [ X${1} = X'/l' ] ; then
+            # test if the first file is present in the old computation :
+	    eval set +A dm_liste \${${2}}
+	else
+	    eval set +A dm_liste ${1}
+	fi
+	eval DEST=\${${#}}
+
+	#=====================================================
+        #         COMMENT OUT DOUBLE COPY ON SCRATCHDIR
+        #=====================================================
+
+	# Is it an R_OUT file (not R_IN) ?
+	#echo ${dm_liste[0]} | grep "${R_OUT}" > /dev/null 2>&1
+	#if [ $? -eq 0 ] ; then
+	#    # Yes  ? then we try to get it in SCRATCHDIR
+	#    set +A file_work $( echo ${dm_liste[*]} | sed -e "s|${R_OUT}|${R_OUT_SCR}|g" )
+	#    if [ -f ${file_work[0]} ] ; then
+	#	IGCM_sys_Cp ${file_work[*]} ${DEST}
+	#	IGCM_debug_PopStack "IGCM_sys_Get"
+	#	return
+	#    fi
+	#fi
+
+	# test if the (first) file is present in the old computation :
+	IGCM_sys_TestFileArchive ${dm_liste[0]}
+	RET=$?
+        if [ ${RET} -gt 0 ] ; then
+	    echo "IGCM_sys_Get, ERROR : regular file ${dm_liste[0]} DOES NOT EXIST ."
+	    IGCM_debug_Exit "IGCM_sys_Get"
+	fi
+
+	ccc_hsm get ${dm_liste[*]} > out_rsync 2>&1
+  	RET=$?
+
+  	if [ ${RET} -gt 0 ] ; then
+	    echo "WARNING IGCM_sys_Get : demigration error."
+	    cat out_rsync
+	    echo "WARNING IGCM_sys_Get : will stop later if the cp fails."
+  	fi
+
+	#if [ ${RET} -gt 0 ] ; then
+	#    if [ ! "X$( grep "Lost dmusrcmd connection" out_rsync )" = "X" ] ; then
+	#	cat out_rsync
+	#	echo "WARNING IGCM_sys_Get : Lost dmusrcmd connection : "
+	#	sleep 30
+	#	echo "We try another time"
+	#	dmget ${dm_liste[*]} > out_rsync 2>&1
+	#	RET=$?
+	#	if [ ${RET} -gt 0 ] ; then
+	#	    echo "ERROR IGCM_sys_Get : again demigration error :"
+	#	    cat out_rsync
+	#	    IGCM_debug_Exit "IGCM_sys_Get"
+	#	fi
+	#    else
+	#	echo "ERROR IGCM_sys_Get : demigration error :"
+	#	cat out_rsync
+	#	IGCM_debug_Exit "IGCM_sys_Get"
+	#    fi
+	#fi
+
+        #USUAL WAY
+	if [ X${1} = X'/l' ] ; then
+	    (( RET=0 ))
+	    for target in ${dm_liste[*]} ; do
+		local_file=$( basename ${target} )
+		\cp ${target} ${DEST}/${local_file} >> out_rsync 2>&1
+		(( RET = RET + $? ))
+	    done
+	else
+	    \cp ${dm_liste} ${DEST} >> out_rsync 2>&1
+	    RET=$?
+	fi
+
+# 	#RSYNC WITH NETWORK SSH CALL
+# 	echo ${RSYNC} ${RSYNC_opt} -e ssh ${RHOST}:"${dm_liste}" ${RHOST}:${RUN_DIR}/${DEST} > out_rsync 2>&1
+# 	${RSYNC} ${RSYNC_opt} -e ssh ${RHOST}:"${dm_liste}" ${RHOST}:${RUN_DIR}/${DEST} >> out_rsync 2>&1
+
+#  	#RSYNC WITH NFS USE
+#  	echo ${RSYNC} ${RSYNC_opt} ${dm_liste} ${RUN_DIR}/${DEST} > out_rsync 2>&1
+#  	${RSYNC} ${RSYNC_opt} ${dm_liste} ${RUN_DIR}/${DEST} >> out_rsync 2>&1
+
+# 	RET=$?
+#  	IGCM_sys_Rsync_out $RET
+
+#  	${libIGCM}/libIGCM_sys/IGCM_analyse_rsync_out.awk out_rsync
+#  	(( RET=RET+$? ))
+
+	if [ ${RET} -gt 0 ] ; then
+	    echo "IGCM_sys_Get : copy error."
+	    cat out_rsync
+	    IGCM_debug_Exit "IGCM_sys_Get"
+	else
+	    \rm out_rsync
+	fi
+    else
+	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+    fi
+    IGCM_debug_PopStack "IGCM_sys_Get"
+}
+
+############################################################## A FINIR !!
+
+#D-#==================================================
+#D-function IGCM_sys_GetDate_FichWork
+#D-* Purpose: donne la date filesys d'un fichier sur le filesystem WORK
+#D-* Examples:
+#D-
+function IGCM_sys_GetDate_FichWork {
+    IGCM_debug_PushStack "IGCM_sys_FichWork" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_GetDate_FichWork :" $@
+    fi
+    # donne la date filesys d'un fichier sur la machine work
+    IGCM_debug_PopStack "IGCM_sys_FichWork"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_GetDate_FichArchive
+#D-* Purpose: donne la date filesys d'un fichier sur le filesystem ARCHIVE 
+#D-* Examples:
+#D-
+function IGCM_sys_GetDate_FichArchive {
+    IGCM_debug_PushStack "IGCM_sys_FichArchive" $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_GetDate_FichArchive :" $@
+    fi
+    IGCM_debug_PopStack "IGCM_sys_FichArchive"
+}
+
+##############################################################
+# REBUILD OPERATOR
+
+function IGCM_sys_rebuild {
+    IGCM_debug_PushStack "IGCM_sys_rebuild" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_rebuild :" $@
+    fi
+    ~p86ipsl/CESIUM/bin/rebuild -f -o $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_rebuild : erreur ${@}."
+       IGCM_debug_Exit "rebuild"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_rebuild"
+}
+
+############################################################
+# Activate Running Environnment Variables
+
+function IGCM_sys_activ_variables {
+    IGCM_debug_PushStack "IGCM_sys_activ_variables"
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_activ_variables"
+    fi
+
+    ulimit -s unlimited
+
+    IGCM_debug_PopStack "IGCM_sys_activ_variables"
+}
+
+############################################################
+# Desactivate Running Environnment Variables
+
+function IGCM_sys_desactiv_variables {
+    IGCM_debug_PushStack "IGCM_sys_desactiv_variables"
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_desactiv_variables"
+    fi
+    IGCM_debug_PopStack "IGCM_sys_desactiv_variables"
+}
+
+
+function IGCM_sys_build_run_file {
+############################################################
+# Build run file
+
+ IGCM_debug_Print 1 "Dummy IGCM_sys_build_run_file"
+
+}
+
+############################################################
+# Build MPI/OMP scripts
+function IGCM_sys_build_execution_scripts 
+{
+    IGCM_debug_PushStack "IGCM_sys_build_execution_scripts" $@
+    if ( $DEBUG_sys ) ; then
+        echo "IGCM_sys_build_execution_scripts " $@
+    fi
+
+    # Verification with MSUB parameter
+	EXECUTION=${HOST_MPIRUN_COMMAND}
+
+    if ( ${OK_PARA_MPMD} ) ; then
+
+        if [ -f run_file ] ; then
+            IGCM_sys_Rm -f run_file
+        fi
+        touch run_file
+
+# run_file construction
+
+# Then first loop on the components for the coupler ie oasis
+
+### the coupler ie oasis must be the first one
+    for comp in ${config_ListOfComponents[*]} ; do
+
+        eval ExeNameIn=\${config_Executable_${comp}[0]}
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+        # for CPL component only
+        if [ "X${comp}" = "XCPL" ] ; then
+
+            eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+            eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
+            echo "${comp_proc_mpi_loc} ./${ExeNameOut}" >> run_file
+        fi
+    done
+
+# Then second loop on the components
+
+    for comp in ${config_ListOfComponents[*]} ; do
+
+        eval ExeNameIn=\${config_Executable_${comp}[0]}
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+        # Only if we really have an executable for the component and not the coupler ie oasis:
+        if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${comp}" != "XCPL" ] ) ; then
+
+            eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+            eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
+            echo "${comp_proc_mpi_loc} ./${ExeNameOut}" >> run_file
+        fi
+    done
+
+    EXECUTION="${HOST_MPIRUN_COMMAND} -f ./run_file"
+
+    IGCM_sys_Chmod u+x run_file
+    if ( $DEBUG_sys ) ; then
+      echo "run_file contains : "
+      cat run_file
+    fi
+
+else # Only one executable. launch it.
+
+    # 
+    for comp in ${config_ListOfComponents[*]} ; do
+
+        eval ExeNameIn=\${config_Executable_${comp}[0]}
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+        if  [ "X${ExeNameOut}" != X\"\" ] ; then
+            if ( ${OK_PARA_MPI} ) ; then
+                eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+                EXECUTION="${EXECUTION} -n ${comp_proc_mpi_loc} ./${ExeNameOut}"
+            else
+                EXECUTION="${EXECUTION} ./${ExeNameOut}"
+            fi
+            if ( ${OK_PARA_OMP} ) ; then
+                eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
+                EXECUTION="export OMP_NUM_THREADS=${comp_proc_omp_loc} ; ${EXECUTION} "
+            fi
+        fi
+
+    done
+
+fi
+
+    IGCM_debug_Print 1 "sys Curie : execution command is "
+    IGCM_debug_Print 1 "$EXECUTION"
+
+    IGCM_debug_PopStack "IGCM_sys_build_execution_scripts"
+}
+
+
+
+##############################################################
+# NCO OPERATOR
+
+function IGCM_sys_ncatted {
+    IGCM_debug_PushStack "IGCM_sys_ncatted" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncatted :" $@
+    fi
+    ncatted "$@"
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncatted : erreur ${@}."
+       IGCM_debug_Exit "ncatted"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncatted"
+}
+
+function IGCM_sys_ncbo {
+    IGCM_debug_PushStack "IGCM_sys_ncbo" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncbo :" $@
+    fi
+    ncbo $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncbo : erreur ${@}."
+       IGCM_debug_Exit "ncbo"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncbo"
+}
+
+function IGCM_sys_ncdiff {
+    IGCM_debug_PushStack "IGCM_sys_ncdiff" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncdiff :" $@
+    fi
+    ncdiff $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncdiff : erreur ${@}."
+       IGCM_debug_Exit "ncdiff"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncdiff"
+}
+
+function IGCM_sys_ncea {
+    IGCM_debug_PushStack "IGCM_sys_ncea" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncea :" $@
+    fi
+    ncea $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncea : erreur ${@}."
+       IGCM_debug_Exit "ncea"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncea"
+}
+
+function IGCM_sys_ncecat {
+    IGCM_debug_PushStack "IGCM_sys_ncecat" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncecat :" $@
+    fi
+    ncecat $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncecat : erreur ${@}."
+       IGCM_debug_Exit "ncecat"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncecat"
+}
+
+function IGCM_sys_ncflint {
+    IGCM_debug_PushStack "IGCM_sys_ncflint" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncflint :" $@
+    fi
+    ncflint $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncflint : erreur ${@}."
+       IGCM_debug_Exit "ncflint"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncflint"
+}
+
+function IGCM_sys_ncks {
+    IGCM_debug_PushStack "IGCM_sys_ncks" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncks :" $@
+    fi
+    ncks $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncks : erreur ${@}."
+       IGCM_debug_Exit "ncks"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncks"
+}
+
+function IGCM_sys_ncpdq {
+    IGCM_debug_PushStack "IGCM_sys_ncpdq" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncpdq :" $@
+    fi
+    ncpdq $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncpdq : erreur ${@}."
+       IGCM_debug_Exit "ncpdq"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncpdq"
+}
+
+function IGCM_sys_ncra {
+    IGCM_debug_PushStack "IGCM_sys_ncra" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncra :" $@
+    fi
+    ncra $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncra : erreur ${@}."
+       IGCM_debug_Exit "ncra"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncra"
+}
+
+function IGCM_sys_ncrcat {
+    IGCM_debug_PushStack "IGCM_sys_ncrcat" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncrcat :" $@
+    fi
+    ncrcat $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncrcat : erreur ${@}."
+#       IGCM_debug_Exit "ncrcat"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncrcat"
+}
+
+function IGCM_sys_ncrename {
+    IGCM_debug_PushStack "IGCM_sys_ncrename" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncrename :" $@
+    fi
+    ncrename $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncrename : erreur ${@}."
+       IGCM_debug_Exit "ncrename"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncrename"
+}
+
+function IGCM_sys_ncwa {
+    IGCM_debug_PushStack "IGCM_sys_ncwa" -- $@
+    if ( $DEBUG_sys ) ; then
+	echo "IGCM_sys_ncwa :" $@
+    fi
+    ncwa $@
+    if [ $? -gt 0 ] ; then
+       echo "IGCM_sys_ncwa : erreur ${@}."
+       IGCM_debug_Exit "ncwa"
+    fi
+
+    IGCM_debug_PopStack "IGCM_sys_ncwa"
+}
